diff --git a/RootStock-NG.sh b/RootStock-NG.sh
index 5851e60b88cd946d5e8c9b5c60e66efa93969730..d3f83f5db2ddba4ecea0d9f22530fdfefa760cef 100755
--- a/RootStock-NG.sh
+++ b/RootStock-NG.sh
@@ -59,6 +59,9 @@ run_project () {
 		apt_proxy="${apt_proxy}"
 		base_pkg_list="${base_pkg_list}"
 
+		chroot_ENABLE_FIRMWARE="${chroot_ENABLE_FIRMWARE}"
+		chroot_ENABLE_DEB_SRC="${chroot_ENABLE_DEB_SRC}"
+
 	__EOF__
 
 	/bin/bash -e "${DIR}/scripts/install_dependencies.sh" || { exit 1 ; }
@@ -79,6 +82,9 @@ a53t|zeus|hestia|poseidon)
 	;;
 esac
 
+chroot_ENABLE_FIRMWARE="enable"
+chroot_ENABLE_DEB_SRC="enable"
+
 distro="debian"
 dpkg_arch="armel"
 
diff --git a/scripts/chroot.sh b/scripts/chroot.sh
index 04fc81779aef28678f8743b92d767ecc4a6cc56f..f33502f0413be5e8a361229a27db1d3fff85dd9b 100755
--- a/scripts/chroot.sh
+++ b/scripts/chroot.sh
@@ -207,9 +207,15 @@ cat > ${DIR}/chroot_script.sh <<-__EOF__
 
 	install_pkg_updates
 	install_pkgs
-	git_firmware
 
-	#dl_pkg_src
+	if [ "x${chroot_ENABLE_FIRMWARE}" == "xenable" ] ; then
+		git_firmware
+	fi
+
+	if [ "x${chroot_ENABLE_DEB_SRC}" == "xenable" ] ; then
+		dl_pkg_src
+	fi
+
 	cleanup
 	rm -f /chroot_script.sh || true
 __EOF__
@@ -221,6 +227,14 @@ sudo chroot ${tempdir} /bin/sh chroot_script.sh
 report_size
 chroot_umount
 
+if [ "x${chroot_ENABLE_DEB_SRC}" == "xenable" ] ; then
+	cd ${tempdir}/tmp/pkg_src/
+	sudo LANG=C tar --numeric-owner -cf ${DIR}/${distro}-${release}-${dpkg_arch}-src.tar .
+	cd ${tempdir}
+	sudo rm -rf ${tempdir}/tmp/pkg_src/ || true
+	report_size
+fi
+
 cd ${tempdir}
 sudo LANG=C tar --numeric-owner -cf ${DIR}/${distro}-${release}-${dpkg_arch}-rootfs.tar .
 cd ${DIR}/